<?php
/**
 * @package   Yandex pay
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class YandexpayControllerMain extends JControllerLegacy
{
  
  public $redirect_main = 'index.php?option=com_yandexpay';
  

  private const API_URL = 'https://pay.yandex.ru';
  private const API_TEST_URL = 'https://sandbox.pay.yandex.ru';
  
  private const NDS = [
    1 => 'COM_YANDEXPAY_NDS_1',
    2 => 'COM_YANDEXPAY_NDS_2',
    3 => 'COM_YANDEXPAY_NDS_3',
    4 => 'COM_YANDEXPAY_NDS_4',
    5 => 'COM_YANDEXPAY_NDS_5',
    6 => 'COM_YANDEXPAY_NDS_6'
  ];
  
  private const MEASURE = [
    0 => 'COM_YANDEXPAY_MEASURE_0',
    10 => 'COM_YANDEXPAY_MEASURE_10',
    11 => 'COM_YANDEXPAY_MEASURE_11',
    12 => 'COM_YANDEXPAY_MEASURE_12',
    20 => 'COM_YANDEXPAY_MEASURE_20',
    21 => 'COM_YANDEXPAY_MEASURE_21',
    22 => 'COM_YANDEXPAY_MEASURE_22',
    30 => 'COM_YANDEXPAY_MEASURE_30',
    31 => 'COM_YANDEXPAY_MEASURE_31',
    32 => 'COM_YANDEXPAY_MEASURE_32',
    40 => 'COM_YANDEXPAY_MEASURE_40',
    41 => 'COM_YANDEXPAY_MEASURE_41',
    42 => 'COM_YANDEXPAY_MEASURE_42',
    50 => 'COM_YANDEXPAY_MEASURE_50',
    51 => 'COM_YANDEXPAY_MEASURE_51',
    70 => 'COM_YANDEXPAY_MEASURE_70',
    71 => 'COM_YANDEXPAY_MEASURE_71',
    72 => 'COM_YANDEXPAY_MEASURE_72',
    73 => 'COM_YANDEXPAY_MEASURE_73',
    80 => 'COM_YANDEXPAY_MEASURE_80',
    81 => 'COM_YANDEXPAY_MEASURE_81',
    82 => 'COM_YANDEXPAY_MEASURE_82',
    83 => 'COM_YANDEXPAY_MEASURE_83',
    255 => 'COM_YANDEXPAY_MEASURE_255'
  ];

  private const METHODTYPE = [
    1 => 'COM_YANDEXPAY_METHODTYPE_1',
    2 => 'COM_YANDEXPAY_METHODTYPE_2',
    3 => 'COM_YANDEXPAY_METHODTYPE_3',
    4 => 'COM_YANDEXPAY_METHODTYPE_4',
    5 => 'COM_YANDEXPAY_METHODTYPE_5',
    6 => 'COM_YANDEXPAY_METHODTYPE_6',
    7 => 'COM_YANDEXPAY_METHODTYPE_7'
  ];
 
  private const SUBJECTTYPE = [
    1 => 'COM_YANDEXPAY_SUBJECTTYPE_1',
    2 => 'COM_YANDEXPAY_SUBJECTTYPE_2',
    3 => 'COM_YANDEXPAY_SUBJECTTYPE_3',
    4 => 'COM_YANDEXPAY_SUBJECTTYPE_4',
    5 => 'COM_YANDEXPAY_SUBJECTTYPE_5',
    6 => 'COM_YANDEXPAY_SUBJECTTYPE_6',
    7 => 'COM_YANDEXPAY_SUBJECTTYPE_7',
    8 => 'COM_YANDEXPAY_SUBJECTTYPE_8',
    9 => 'COM_YANDEXPAY_SUBJECTTYPE_9',
    10 => 'COM_YANDEXPAY_SUBJECTTYPE_10',
    11 => 'COM_YANDEXPAY_SUBJECTTYPE_11',
    12 => 'COM_YANDEXPAY_SUBJECTTYPE_12',
    13 => 'COM_YANDEXPAY_SUBJECTTYPE_13',
    14 => 'COM_YANDEXPAY_SUBJECTTYPE_14',
    15 => 'COM_YANDEXPAY_SUBJECTTYPE_15',
    16 => 'COM_YANDEXPAY_SUBJECTTYPE_16',
    17 => 'COM_YANDEXPAY_SUBJECTTYPE_17',
    18 => 'COM_YANDEXPAY_SUBJECTTYPE_18',
    19 => 'COM_YANDEXPAY_SUBJECTTYPE_19',
    20 => 'COM_YANDEXPAY_SUBJECTTYPE_20',
    21 => 'COM_YANDEXPAY_SUBJECTTYPE_21',
    22 => 'COM_YANDEXPAY_SUBJECTTYPE_22',
    23 => 'COM_YANDEXPAY_SUBJECTTYPE_23',
    24 => 'COM_YANDEXPAY_SUBJECTTYPE_24',
    25 => 'COM_YANDEXPAY_SUBJECTTYPE_25',
    26 => 'COM_YANDEXPAY_SUBJECTTYPE_26'
  ];
  
  private const AGENTTYPE = [
    1 => 'COM_YANDEXPAY_AGENTTYPE_1',
    2 => 'COM_YANDEXPAY_AGENTTYPE_2',
    3 => 'COM_YANDEXPAY_AGENTTYPE_3',
    4 => 'COM_YANDEXPAY_AGENTTYPE_4',
    5 => 'COM_YANDEXPAY_AGENTTYPE_5',
    6 => 'COM_YANDEXPAY_AGENTTYPE_6',
    7 => 'COM_YANDEXPAY_AGENTTYPE_7'
  ];  


  function __construct($config = array()){
    parent::__construct( $config );
    $this->registerTask('apply', 'save');
  }
  
  function display($cachable = false, $urlparams = false){  

    $params = JComponentHelper::getParams('com_yandexpay');

    // Подключили шаблон страницы
    $view = $this->getView('yandexpay', 'html');
    $view->setLayout('main');
    
    // Добавляем переменные в шаблон
    $view->assign('shop_name', $params->get('shop_name', ''));
    $view->assign('domains', $params->get('domains', ''));
    $view->assign('callback_url', $params->get('callback_url', ''));
    $view->assign('merchant_id', $params->get('merchant_id', ''));
    $view->assign('key_api', $params->get('key_api', ''));
    $view->assign('working_mode', $params->get('working_mode', ''));
    //
    $view->assign('btn_view_product_card', $params->get('btn_view_product_card', ''));
    $view->assign('btn_view_cart', $params->get('btn_view_cart', ''));
    //
    $view->assign('btn_color', $params->get('btn_color', ''));
    $view->assign('btn_width', $params->get('btn_width', ''));
    $view->assign('btn_class', $params->get('btn_class', ''));
    $view->assign('btn_margin_top', $params->get('btn_margin_top', 0));
    $view->assign('btn_margin_right', $params->get('btn_margin_right', 0));
    $view->assign('btn_margin_bottom', $params->get('btn_margin_bottom', 0));
    $view->assign('btn_margin_left', $params->get('btn_margin_left', 0));
    //
    $view->assign('delivery_name', $params->get('delivery_name', ''));
    $view->assign('delivery_amount', $params->get('delivery_amount', 0));
    $view->assign('delivery_date', $params->get('delivery_date', 0));
    // fns
    $view->assign('fns_tax_list', self::NDS);
    $view->assign('fns_measure_list', self::MEASURE);
    $view->assign('fns_paymentMethodType_list', self::METHODTYPE);
    $view->assign('fns_paymentSubjectType_list', self::SUBJECTTYPE);
    $view->assign('fns_agent_type_list', self::AGENTTYPE);
    
    $view->assign('fns_active', $params->get('fns_active', 'no'));
    $view->assign('fns_title', $params->get('fns_title', ''));
    $view->assign('fns_tax', $params->get('fns_tax', ''));
    $view->assign('fns_measure', $params->get('fns_measure', '-'));
    $view->assign('fns_paymentMethodType', $params->get('fns_paymentMethodType', ''));
    $view->assign('fns_paymentSubjectType', $params->get('fns_paymentSubjectType', ''));
    $view->assign('fns_excise', $params->get('fns_excise', ''));
    $view->assign('fns_productCode', $params->get('fns_productCode', ''));
    $view->assign('fns_markQuantity_1', $params->get('fns_markQuantity_1', ''));
    $view->assign('fns_markQuantity_2', $params->get('fns_markQuantity_2', ''));
    $view->assign('fns_supplier_name', $params->get('fns_supplier_name', ''));
    $view->assign('fns_supplier_inn', $params->get('fns_supplier_inn', ''));
    $view->assign('fns_supplier_phones', $params->get('fns_supplier_phones', ''));
    $view->assign('fns_agent_type', $params->get('fns_agent_type', ''));
    $view->assign('fns_agent_operation', $params->get('fns_agent_operation', ''));
    $view->assign('fns_agent_phones', $params->get('fns_agent_phones', ''));
    $view->assign('fns_agent_transferOperator_name', $params->get('fns_agent_transferOperator_name', ''));
    $view->assign('fns_agent_transferOperator_address', $params->get('fns_agent_transferOperator_address', ''));
    $view->assign('fns_agent_transferOperator_inn', $params->get('fns_agent_transferOperator_inn', ''));
    $view->assign('fns_agent_transferOperator_phones', $params->get('fns_agent_transferOperator_phones', ''));
    $view->assign('fns_agent_paymentsOperator_phones', $params->get('fns_agent_paymentsOperator_phones', ''));

    $view->displayMain(); 
  }
  
  public function save(){
    if ($this->checkToken['save']){
      JSession::checkToken() or die('Invalid Token');
    }
    
    $working_mode = $this->input->get('working_mode', '', 'STRING');
    
    $params = JComponentHelper::getParams('com_yandexpay');

    $params->set('shop_name', $this->input->get('shop_name', '', 'STRING'));
    $params->set('domains', $this->input->get('domains', '', 'STRING'));
    $params->set('callback_url', $this->input->get('callback_url', '', 'STRING'));
    $params->set('merchant_id', $this->input->get('merchant_id', '', 'STRING'));
    $params->set('key_api', $this->input->get('key_api', '', 'STRING'));
    $params->set('working_mode', $working_mode);
    //
    $params->set('btn_view_product_card', $this->input->get('btn_view_product_card', '', 'STRING'));
    $params->set('btn_view_cart', $this->input->get('btn_view_cart', '', 'STRING'));
    //
    $params->set('btn_color', $this->input->get('btn_color', '', 'STRING'));
    $params->set('btn_width', $this->input->get('btn_width', '', 'STRING'));
    $params->set('btn_class', $this->input->get('btn_class', '', 'STRING'));
    $params->set('btn_margin_top', $this->input->get('btn_margin_top', '', 'INT'));
    $params->set('btn_margin_right', $this->input->get('btn_margin_right', '', 'INT'));
    $params->set('btn_margin_bottom', $this->input->get('btn_margin_bottom', '', 'INT'));
    $params->set('btn_margin_left', $this->input->get('btn_margin_left', '', 'INT'));
    //
    $params->set('delivery_name', $this->input->get('delivery_name', '', 'STRING'));
    $params->set('delivery_amount', $this->input->get('delivery_amount', '', 'INT'));
    $params->set('delivery_date', $this->input->get('delivery_date', '', 'INT'));
    // fns
    $params->set('fns_active', $this->input->get('fns_active', '', 'STRING'));
    $params->set('fns_title', $this->input->get('fns_title', '', 'STRING'));
    $params->set('fns_tax', $this->input->get('fns_tax', '', 'INT'));
    $params->set('fns_measure', $this->input->get('fns_measure', '-', 'STRING'));
    $params->set('fns_paymentMethodType', $this->input->get('fns_paymentMethodType', '', 'INT'));
    $params->set('fns_paymentSubjectType', $this->input->get('fns_paymentSubjectType', '', 'INT'));
    $params->set('fns_excise', $this->input->get('fns_excise', '', 'STRING'));
    $params->set('fns_productCode', $this->input->get('fns_productCode', '', 'STRING'));
    $params->set('fns_markQuantity_1', $this->input->get('fns_markQuantity_1', '', 'INT'));
    $params->set('fns_markQuantity_2', $this->input->get('fns_markQuantity_2', '', 'INT'));
    $params->set('fns_supplier_name', $this->input->get('fns_supplier_name', '', 'STRING'));
    $params->set('fns_supplier_inn', $this->input->get('fns_supplier_inn', '', 'STRING'));
    $params->set('fns_supplier_phones', $this->input->get('fns_supplier_phones', '', 'STRING'));
    $params->set('fns_agent_type', $this->input->get('fns_agent_type', '', 'INT'));
    $params->set('fns_agent_operation', $this->input->get('fns_agent_operation', '', 'STRING'));
    $params->set('fns_agent_phones', $this->input->get('fns_agent_phones', '', 'STRING'));
    $params->set('fns_agent_transferOperator_name', $this->input->get('fns_agent_transferOperator_name', '', 'STRING'));
    $params->set('fns_agent_transferOperator_address', $this->input->get('fns_agent_transferOperator_address', '', 'STRING'));
    $params->set('fns_agent_transferOperator_inn', $this->input->get('fns_agent_transferOperator_inn', '', 'STRING'));
    $params->set('fns_agent_transferOperator_phones', $this->input->get('fns_agent_transferOperator_phones', '', 'STRING'));
    $params->set('fns_agent_paymentsOperator_phones', $this->input->get('fns_agent_paymentsOperator_phones', '', 'STRING'));

    //Hide
    $api_url = ($working_mode == 'test') ? self::API_TEST_URL : self::API_URL;
    $params->set('api_url', $api_url);

    $componentid = JComponentHelper::getComponent('com_yandexpay')->id;
    $table = JTable::getInstance('extension');
    $table->load($componentid);
    $table->bind(array('params' => $params->toString()));
    $table->check();
    $table->store();

    $this->setRedirect($this->redirect_main);
  }
  
}