<?php
/**
 * @package   Yandex pay
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class YandexpayControllerRefund extends JControllerLegacy
{
  
  public $redirect_main = 'index.php?option=com_yandexpay&amp;controller=refund';  

  function __construct($config = array()){
    JLoader::register('YPHelpers', JPATH_ROOT . '/libraries/yandexapi/YPHelpers.php');
    $this->YPHelpers = new YPHelpers();
  
    parent::__construct( $config );
    $this->registerTask('apply', 'save');
  }
  
  function display($cachable = false, $urlparams = false){  

    $params = JComponentHelper::getParams('com_yandexpay');

    $view = $this->getView('yandexpay', 'html');
    $view->setLayout('refund');
    
    $orders = $this->YPHelpers->getOrderListForRefund();

    $view->assign('orders', $orders);

    $view->displayMain(); 
  }
  
  public function save(){
    if ($this->checkToken['save']){
      JSession::checkToken() or die('Invalid Token');
    }
    
    $working_mode = $this->input->get('working_mode', '', 'STRING');
    
    $params = JComponentHelper::getParams('com_yandexpay');

    $params->set('shop_name', $this->input->get('shop_name', '', 'STRING'));
    $params->set('domains', $this->input->get('domains', '', 'STRING'));
    $params->set('callback_url', $this->input->get('callback_url', '', 'STRING'));
    $params->set('merchant_id', $this->input->get('merchant_id', '', 'STRING'));
    $params->set('key_api', $this->input->get('key_api', '', 'STRING'));
    $params->set('working_mode', $working_mode);
    //
    $params->set('btn_view_product_card', $this->input->get('btn_view_product_card', '', 'STRING'));
    $params->set('btn_view_cart', $this->input->get('btn_view_cart', '', 'STRING'));
    //
    $params->set('btn_color', $this->input->get('btn_color', '', 'STRING'));
    $params->set('btn_width', $this->input->get('btn_width', '', 'STRING'));
    $params->set('btn_class', $this->input->get('btn_class', '', 'STRING'));
    $params->set('btn_margin_top', $this->input->get('btn_margin_top', '', 'INT'));
    $params->set('btn_margin_right', $this->input->get('btn_margin_right', '', 'INT'));
    $params->set('btn_margin_bottom', $this->input->get('btn_margin_bottom', '', 'INT'));
    $params->set('btn_margin_left', $this->input->get('btn_margin_left', '', 'INT'));
    //
    $params->set('delivery_name', $this->input->get('delivery_name', '', 'STRING'));
    $params->set('delivery_amount', $this->input->get('delivery_amount', '', 'INT'));
    $params->set('delivery_date', $this->input->get('delivery_date', '', 'INT'));
    
    //Hide
    $api_url = ($working_mode == 'test') ? self::API_TEST_URL : self::API_URL;
    $params->set('api_url', $api_url);

    $componentid = JComponentHelper::getComponent('com_yandexpay')->id;
    $table = JTable::getInstance('extension');
    $table->load($componentid);
    $table->bind(array('params' => $params->toString()));
    $table->check();
    $table->store();

    $this->setRedirect($this->redirect_main);
  }
  
}