<?php
  /**
 * @package   Labyrinth
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class YPHelpers{
    
  function createTempOrderID($id) {
    $length = 10;
    $chars='qazxswedcvfrtgbnhyujmkiolp1234567890'; 
    $size = StrLen($chars)-1; 
    $output = ''; 
    
    while($length--){
      $output .= $chars[rand(0,$size)]; 
    }

    return $id.'_'.time().'_'.$output;
  }

  function getSettings(){
    $params = JComponentHelper::getParams('com_yandexpay');

    $yp_settings = [
      'shop_name' => $params->get('shop_name', ''),
      'domains' => $params->get('domains', ''),
      'callback_url' => $params->get('callback_url', ''),
      'merchant_id' => $params->get('merchant_id', ''),
      'key_api' => $params->get('key_api', ''),
      'working_mode' => $params->get('working_mode', ''),
      //
      'btn_view_product_card' => $params->get('btn_view_product_card', ''),
      'btn_view_cart' => $params->get('btn_view_cart', ''),
      'btn_view_checkout' => $params->get('btn_view_checkout', ''),
      //
      'btn_color' => $params->get('btn_color', 'White'),
      'btn_width' => $params->get('btn_width', 'Auto'),
      'btn_class' => $params->get('btn_class', ''),
      'btn_margin_top' => $params->get('btn_margin_top', '0'),
      'btn_margin_right' => $params->get('btn_margin_right', '0'),
      'btn_margin_bottom' => $params->get('btn_margin_bottom', '0'),
      'btn_margin_left' => $params->get('btn_margin_left', '0'),
      //
      'delivery_name' => $params->get('delivery_name', ''),
      'delivery_amount' => $params->get('delivery_amount', ''),
      'delivery_date' => $params->get('delivery_date', ''),
      // fns
      'fns_active' => $params->get('fns_active', 'no'),
      'fns_title' => $params->get('fns_title', ''),
      'fns_tax' => $params->get('fns_tax', '-'),
      'fns_measure' => $params->get('fns_measure', '-'),
      'fns_paymentMethodType' => $params->get('fns_paymentMethodType', '-'),
      'fns_paymentSubjectType' => $params->get('fns_paymentSubjectType', '-'),
      'fns_excise' => $params->get('fns_excise', ''),
      'fns_productCode' => $params->get('fns_productCode', ''),
      'fns_markQuantity_1' => $params->get('fns_markQuantity_1', ''),
      'fns_markQuantity_2' => $params->get('fns_markQuantity_2', ''),
      'fns_supplier_name' => $params->get('fns_supplier_name', ''),
      'fns_supplier_inn' => $params->get('fns_supplier_inn', ''),
      'fns_supplier_phones' => $params->get('fns_supplier_phones', ''),
      'fns_agent_type' => $params->get('fns_agent_type', '-'),
      'fns_agent_operation' => $params->get('fns_agent_operation', ''),
      'fns_agent_phones' => $params->get('fns_agent_phones', ''),
      'fns_agent_transferOperator_name' => $params->get('fns_agent_transferOperator_name', ''),
      'fns_agent_transferOperator_address' => $params->get('fns_agent_transferOperator_address', ''),
      'fns_agent_transferOperator_inn' => $params->get('fns_agent_transferOperator_inn', ''),
      'fns_agent_transferOperator_phones' => $params->get('fns_agent_transferOperator_phones', ''),
      'fns_agent_paymentsOperator_phones' => $params->get('fns_agent_paymentsOperator_phones', ''),
      //hide
      'api_url' => $params->get('api_url', ''),
    ];

    if(empty($yp_settings['merchant_id'])){
      return false;
    }
    
    return $yp_settings;
  }
  
  function saveCart($cart){
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);

    $columns = ['virtuemart_cart_id', 'temp_cart_id', 'cartData', 'yandexData'];
    $values = [0, 0, $db->quote($cart), 0];

    $query
      ->insert($db->quoteName('#__yandexpay_carts'))
      ->columns($db->quoteName($columns))
      ->values(implode(',', $values));

    $db->setQuery($query);
    $db->execute();
   
    return $db->insertid();
  }

  function updateCart($id, $cartData = null,  $temp_cart_id = null, $yandexData = null){
    $db = JFactory::getDbo();

    $query = $db->getQuery(true);
    
    $fields = [];
    
    if(!is_null($cartData)){
      $fields[] = $db->quoteName('cartData') . ' = ' . $db->quote($cartData);
    }
    
    if(!is_null($temp_cart_id)){
      $fields[] = $db->quoteName('temp_cart_id') . ' = ' . $db->quote($temp_cart_id);
    }  
    
    if(!is_null($yandexData)){
      $fields[] = $db->quoteName('yandexData') . ' = ' . $db->quote($yandexData);
    }    

    $conditions = [
      $db->quoteName('cart_id') . ' = '.$id
    ];

    $query->update($db->quoteName('#__yandexpay_carts'))->set($fields)->where($conditions);

    $db->setQuery($query);

    return $db->execute();
  }
  
  function getTempCart($cart_id){
    $db = JFactory::getDbo();
    $query = $db->getQuery(true)
        ->select($db->quoteName('cartData'))
        ->from($db->quoteName('#__yandexpay_carts'))
        ->where($db->quoteName('cart_id') . ' = ' . $db->quote($cart_id));
    $db->setQuery($query);

    if ($cartData = $db->loadResult()){
      return json_decode($cartData);
    }else{
      return null;
    }
  }
  
  function deleteTempCart($temp_cart_id){
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);

    $conditions = array(
      $db->quoteName('temp_cart_id') . ' = ' . $db->quote($temp_cart_id)
    );

    $query->delete($db->quoteName('#__yandexpay_carts'));
    $query->where($conditions);
    $db->setQuery($query);
    $db->execute();  
  }
  
  function createNewUser($params){

    $udata = [
      'name' => $params['name'],
      'username' => $params['username'],
      'password' => $params['email'],
      'email' => $params['email'],
      'groups' => [2]
    ];

    $user = new JUser;

    try{
      $user->bind($udata);
      $user->save();
      $app = JFactory::getApplication();
      $app->login( array('username'=>$params['username'],'password'=>$params['password']) );
      
    } catch (Exception $ex) {
      echo 'Exception: ',  $e->getMessage(), '\n';
    } 
  }

  function getUserIdByEmail($email){
    $db = JFactory::getDbo();
    $query = $db->getQuery(true)
        ->select($db->quoteName('id'))
        ->from($db->quoteName('#__users'))
        ->where($db->quoteName('email') . ' = ' . $db->quote($email));
    $db->setQuery($query);

    if ($id = $db->loadResult()){
      return JFactory::getUser($id);
    }else{
      return null;
    }
  }

  function getYandexPayMethod(){
    $paymentmethod = VmModel::getModel('paymentmethod');
    
    $output = [];
    $lists = $paymentmethod->getPayments();
    
    foreach($lists as $list){
      if($list->payment_element == 'yandexpay'){
        $output = $list;
        break;
      }    
    }
    
    return $output;
  }

  function getOrderTotal($order_id){
  
    $db = JFactory::getDbo();
    $query = $db->getQuery(true)
        ->select($db->quoteName('order_total'))
        ->from($db->quoteName('#__virtuemart_orders'))
        ->where($db->quoteName('virtuemart_order_id') . ' = ' . $db->quote($order_id));
    $db->setQuery($query);

    if ($order_total = $db->loadResult()){
      return $order_total;
    }else{
      return null;
    }
  } 
  
  function getOrderCoupon($order_id){
  
    $db = JFactory::getDbo();
    $query = $db->getQuery(true)
        ->select($db->quoteName('coupon_code'))
        ->from($db->quoteName('#__virtuemart_orders'))
        ->where($db->quoteName('virtuemart_order_id') . ' = ' . $db->quote($order_id));
    $db->setQuery($query);

    if ($coupon_code = $db->loadResult()){
      return $coupon_code;
    }else{
      return null;
    }
  } 
  
  function createOrder($ids = [], $qts = [], $user = [], $shipping_cost = 0, $comment = '', $discount = null){
		JLoader::register('VirtueMartCart', $vmpath_site.'/helpers/cart.php'); 

    $orderModel = VmModel::getModel('orders');

    vRequest::setVar ( 'quantity', $qts );

    $cart = VirtueMartCart::getCart(true);
    $cart->tempCart = true;
    $cart->add($ids);    

    foreach($cart->products as $key=>$product){
      if(!in_array($product->virtuemart_product_id, $ids)){
        $cart->removeProductCart($key);        
      }
    }
    
    // Присваиваем адрес    
    $BtStEmpty = false;
    $BT = [];
    $ST = [];
		$currentUser = $this->getUserIdByEmail($user['email']);
    
		if(!is_null($currentUser)){

      $userModel = VmModel::getModel('user');
      $stData = $userModel->getUserAddressList($currentUser->id, 'ST');
      $btData = $userModel->getUserAddressList($currentUser->id, 'BT');
      
      if(isset($stData[0])){
        $ST = [
         'last_name' => $stData[0]->last_name,
         'first_name' => $stData[0]->first_name,
         'phone_1' => $stData[0]->phone_1,
         'address_1' => $stData[0]->address_1,
         'city' => $stData[0]->city,
         'virtuemart_state_id' => $stData[0]->virtuemart_state_id,
         'virtuemart_country_id' => $stData[0]->virtuemart_country_id,
         'zip' => $stData[0]->zip,
         'email' => $stData[0]->email,
        ];
      }
      
      if(isset($btData[0])){
        $BT = [
         'last_name' => $btData[0]->last_name,
         'first_name' => $btData[0]->first_name,
         'phone_1' => $btData[0]->phone_1,
         'address_1' => $btData[0]->address_1,
         'city' => $btData[0]->city,
         'virtuemart_state_id' => $btData[0]->virtuemart_state_id,
         'virtuemart_country_id' => $btData[0]->virtuemart_country_id,
         'zip' => $btData[0]->zip,
         'email' => $btData[0]->email,
        ];
      }
      
      if(count($ST) == 0) $ST = $BT;
      if(count($BT) == 0) $BT = $ST;
      if(count($BT) == 0 && count($ST) == 0) $BtStEmpty = true;
		}

    // Создаем нового пользователя
    if(is_null($currentUser)){
      $params = [
        'name' => $user['last_name'].' '.$user['first_name'],
        'username' => $user['last_name'].' '.$user['first_name'],
        'password' => $user['email'],
        'email' => $user['email'],
        'groups' => [2]
      ];
      
      $this->createNewUser($params);
      $BtStEmpty = true;
    }
    
    // Заполняем данные поьзователя на сайте, данными с яндекса    
    if($BtStEmpty == true){
      $ST = $BT = [
       'last_name' => $user['last_name'],
       'first_name' => $user['first_name'],
       'phone_1' => $user['phone_1'],
       'address_1' => $user['address_1'],
       'city' => $user['city'],
       'zip' => $user['zip'],
       'email' => $user['email'],
      ];
    }

    $cart->BT = $BT;
    $cart->ST = $ST;    
    
    $cart->BT['order_shipment'] = $shipping_cost;
    $cart->ST['order_shipment'] = $shipping_cost;

    $paymentmethod = $this->getYandexPayMethod();
    $cart->virtuemart_paymentmethod_id = $paymentmethod->virtuemart_paymentmethod_id;
    $cart->virtuemart_shipmentmethod_id = 0; 

    $cart->getCartPrices(true);
    $cart->prepareCartData();

    // Создане заказа
    $order_id = $orderModel->createOrderFromCart($cart);
    $order = $orderModel->getOrder($order_id);
    $order_total = $order['details']['BT']->order_total + $shipping_cost;    
    
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);
    
    $discount_fields = [];
    
    if(!is_null($discount)){
      $order_total = $order_total - $discount['amount'];
      
      $discount_fields = [
        $db->quoteName('coupon_discount') . ' = ' . $db->quote(number_format(($discount['amount']*-1), 2, '.', '')),
        $db->quoteName('coupon_code') . ' = ' . $db->quote($discount['code']),
      ];
    }

    $order_fields = [
      $db->quoteName('order_note') . ' = ' . $db->quote($comment),
      $db->quoteName('order_total') . ' = ' . $db->quote($order_total),
    ];

    $fields = array_merge($order_fields, $discount_fields);

    $conditions = [
      $db->quoteName('virtuemart_order_id') . ' = ' . $db->quote($order_id)
    ];

    $query->update($db->quoteName('#__virtuemart_orders'))->set($fields)->where($conditions);
    $db->setQuery($query);
    $db->execute();    
    
    $cart->emptyCart();
    unset($cart);    
    
    $session = JFactory::getSession();
    $temp_cart_id = $session->get('temp_cart_id', 0, 'YandexPay');

    if($temp_cart_id != 0){
      $this->deleteTempCart($temp_cart_id);
      $session->set('temp_cart_id', 0, 'YandexPay');
    }    
    
    return $order_id;
  }
  
  function updateNativeOrder($order_id, $shipping_amount, $comment, $discount = null){
    $order_total = $this->getOrderTotal($order_id);
    
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);

    $discount_fields = [];
    
    if(!is_null($discount)){
      $coupon = $this->getOrderCoupon($order_id);
      
      if(is_null($coupon)){
        $order_total = $order_total - $discount['amount'];
      }
      
      $discount_fields = [
        $db->quoteName('coupon_discount') . ' = ' . $db->quote(number_format(($discount['amount']*-1), 2, '.', '')),
        $db->quoteName('coupon_code') . ' = ' . $db->quote($discount['code']),
      ];
    }

    $order_fields = [
      $db->quoteName('order_note') . ' = ' . $db->quote($comment),
      $db->quoteName('order_shipment') . ' = ' . $db->quote($shipping_amount),
      $db->quoteName('order_total') . ' = ' . $db->quote($order_total + $shipping_amount),
    ];
    
    $fields = array_merge($order_fields, $discount_fields);

    $conditions = [
      $db->quoteName('virtuemart_order_id') . ' = ' . $db->quote($order_id)
    ];

    $query->update($db->quoteName('#__virtuemart_orders'))->set($fields)->where($conditions);
    $db->setQuery($query);
    $db->execute();
  }
  
  function updateOrderComment($order_id, $message){
    $db = JFactory::getDbo();
    
    $query = $db->getQuery(true)
        ->select($db->quoteName('order_note'))
        ->from($db->quoteName('#__virtuemart_orders'))
        ->where($db->quoteName('virtuemart_order_id') . ' = ' . $db->quote($order_id));
    $db->setQuery($query);

    if ($order_note = $db->loadResult()){
      $time = '# '.date('Y-m-d H:i:s', time()).' #';
      
      $query = $db->getQuery(true);      
      
      $fields = [
        $db->quoteName('order_note') . ' = ' . $db->quote("$order_note \r\n\r\n $time\r\n$message"),
      ];

      $conditions = [
        $db->quoteName('virtuemart_order_id') . ' = ' . $db->quote($order_id)
      ];

      $query->update($db->quoteName('#__virtuemart_orders'))->set($fields)->where($conditions);
      $db->setQuery($query);
      $db->execute();
    }
  }
  
  function updateOrderStatus($order_id, $status = 'P'){
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);      
    
    $fields = [
      $db->quoteName('order_status') . ' = ' . $db->quote($status),
    ];

    $conditions = [
      $db->quoteName('virtuemart_order_id') . ' = ' . $db->quote($order_id)
    ];

    $query->update($db->quoteName('#__virtuemart_orders'))->set($fields)->where($conditions);
    $db->setQuery($query);
    $db->execute();
  }
  
  function updateOrderPaidStatus($order_id, $amountSumm = 0, $time){
    $db = JFactory::getDbo();
    $time = date('Y-m-d H:i:s', strtotime($time));

    $query = $db->getQuery(true);      
    
    $fields = [
    $db->quoteName('paid') . ' = ' . $db->quote($amountSumm),
    $db->quoteName('paid_on') . ' = ' . $db->quote($time),
    ];

    $conditions = [
      $db->quoteName('virtuemart_order_id') . ' = ' . $db->quote($order_id)
    ];

    $query->update($db->quoteName('#__virtuemart_orders'))->set($fields)->where($conditions);
    $db->setQuery($query);
    $db->execute();
  }
  
  function getCouponAmount($id, $type_order = 'cart', $coupon_code = '', $token = null){
    JLoader::register('CouponHelper', $vmpath_site.'/helpers/coupon.php');
    $productModel = VmModel::getModel ('product');
    $id = explode('_', $id);

    if($type_order == 'cart'){
      $cart = $this->getTempCart($id[0]);      
      $coupon_code = ($coupon_code != '') ? $coupon_code : $cart->couponCode;      
      $coupon_details = CouponHelper::getCouponDetails( $coupon_code ); 
      $items = $cart->cartProductsData;
    }elseif($type_order == 'native'){
      $model = VmModel::getModel('orders');
      $order = $model->getOrder($id[0]);      
      $coupon_code = ($coupon_code != '') ? $coupon_code : $order['details']['BT']->coupon_code; 
      $coupon_details = CouponHelper::getCouponDetails( $coupon_code ); 
      $items = $order['items'];      
    }elseif($type_order == 'product_card'){
      $items = [(Object)[
        'virtuemart_product_id' =>  $token->cart->items[0]->productId,
        'quantity' =>  $token->cart->items[0]->quantity->count,
      ]]; 
      $coupon_details = CouponHelper::getCouponDetails( $coupon_code );
    }

    if(is_null($coupon_details)){
      return null;
    }    
    
    $discount = 0;       
    $total = 0;       
    
    foreach($items as $item){    
      $qty = isset($item->quantity) ? $item->quantity : $item->product_quantity;    
    
      $product = $productModel->getProduct($item->virtuemart_product_id);
      $price = $product->prices['salesPrice'];
      $discount += ($price * $qty * ($coupon_details->coupon_value / 100));
      $total += $price * $qty;
    }
    
    if($type_order == 'cart' && ($valid = CouponHelper::ValidateCouponCode($coupon_code, $total)) != ''){
      return 'not_valid';
    }

    if($coupon_details->percent_or_total == 'total'){
      return ['code' => $coupon_code, 'amount' => $coupon_details->coupon_value];
    }
    
    if($coupon_details->percent_or_total == 'percent'){
      return ['code' => $coupon_code, 'amount' => $discount];
    }    

    return null;  
  }
  
  function checkCoupon($token){
  
    if(!isset($token->cart->coupons)){
      return '';
    }
    
    $coupon = array_shift($token->cart->coupons);
    return $coupon->value; 
  }
  
  function saveYPOrderId($order_id, $yp_order_id){
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);

    $fields = [
      $db->quoteName('yp_order_id') . ' = ' . $db->quote($yp_order_id)
    ];

    $conditions = [
      $db->quoteName('virtuemart_order_id') . ' = ' . $db->quote($order_id)
    ];

    $query->update($db->quoteName('#__virtuemart_orders'))->set($fields)->where($conditions);
    $db->setQuery($query);
    $db->execute();  
  }
  
  function getOrderListForRefund(){
    $db = JFactory::getDbo();
    $query = $db->getQuery(true)
        ->select($db->quoteName('yp_order_id'))
        ->from($db->quoteName('#__virtuemart_orders'))
        ->where($db->quoteName('yp_order_id') . ' > ""')
        ->order('virtuemart_order_id DESC');
    $db->setQuery($query);

    if ($data = $db->loadObjectList()){
      return $data;
    }else{
      return null;
    }
  }
}