var yandexPayCheckoutData = false;

(function($) {
 
  var yandexPayShow = false;
  var debugStatus = true;

  $(window).load(function() { yandexPayShow = true; });   

  $(document).ready(function(){

    var YaPay;
    var checkoutData;
    var checkoutObject;
    var buttonTypeUsed = 'Checkout'; // Checkout / Pay
    
    var btnContainer;
    var orderOneProduct;    
    var btnView = btnViewCheck();
    var ypProductCard = $('.yandex-pay-button-product-card');  
    
    debugMessages(yp_product);

    if(btnView == true && yandexPayShow == false){
      var timerYP = setInterval(function(){
            if(yandexPayShow == true){
              clearInterval(timerYP);
              startYP();              
            }
          }, 500);
    }
    
    function startYP(){
      var error = false;
      btnContainer = document.querySelectorAll("#yandex_pay_button_container");
      
      if(yp_product == undefined){
        debugMessages('Yandex: отсутствуют данные о товаре');
        error = true;
      }

      if(yp_settings.merchant_id == undefined || yp_settings.merchant_id == ''){
        debugMessages('Yandex: отсутствуют данные мерчанта');
        error = true;
      }

      if(error == false && btnContainer.length == 1){

        YaPay = window.YaPay;
        btnContainer = btnContainer[0];

        onYaPayLoad();
      }  
    }

    function onYaPayLoad() {
      const YaPay = window.YaPay;

      var CurrencyCode = 'Rub';
      
      if(yp_currency != undefined && yp_currency != ''){
        yp_currency = yp_currency.toLowerCase();
        CurrencyCode = yp_currency[0].toUpperCase() + yp_currency.slice(1);
      }
      
      if(yp_any_data == undefined){
        yp_any_data = 'empty';
      }
      
      var workingMode = 'Sandbox';
      
      if(yp_settings.working_mode == 'prod'){
        workingMode = 'Production';
      }

      // Сформировать данные платежа.
      const checkoutData = {
        env: YaPay.PaymentEnv[workingMode],
        version: 3,
        currencyCode: YaPay.CurrencyCode[CurrencyCode],
        name: yp_settings.shop_name,
        merchantId: yp_settings.merchant_id,
        cart: yp_product,
        orderId: yp_product.externalId,
        metadata: yp_any_data,
      };
      
      YaPay.createCheckout(checkoutData)
        .then(function (checkout) {
          yandexPayCheckoutData = checkout;
          createPaymentButton();
        })
        .catch(function (err) {
          debugMessages(err);
        });
    }

    // Создаем кнопку для сайта
    function createPaymentButton(){
      
      if(yp_settings.btn_class != ''){
        btnContainer.classList.add(yp_settings.btn_class);
      }
      
      var top = yp_settings.btn_margin_top + 'px ';
      var right = yp_settings.btn_margin_right + 'px ';
      var bottom = yp_settings.btn_margin_bottom + 'px ';
      var left = yp_settings.btn_margin_left + 'px ';      
      
      btnContainer.setAttribute('style', 'margin:' + top + right + bottom + left);

      yandexPayCheckoutData.mountButton(btnContainer, {
        type: YaPay.ButtonType[buttonTypeUsed],
        theme: YaPay.ButtonTheme[yp_settings.btn_color],
        width: YaPay.ButtonWidth[yp_settings.btn_width],
      }); 

      // Подписываемся на события
      yandexPayCheckoutData.on(YaPay.CheckoutEventType.Success, onCheckoutSuccess);
      yandexPayCheckoutData.on(YaPay.CheckoutEventType.Error, onCheckoutError);
      yandexPayCheckoutData.on(YaPay.CheckoutEventType.Abort, onCheckoutAbort);
      
      var btnNativPayment = $('.yandex-pay-button-nativ-payment');
      
      if(btnNativPayment.length > 0){
        //yandexPayCheckoutData.checkout();
      } 
    }
    
    if(ypProductCard.length > 0){
    
      //
      $('.quantity-controls.quantity-plus, .quantity-controls.quantity-minus').click(function(){
        var qty = parseInt($('.quantity-input').val());
        
        if($(this).hasClass('quantity-plus') == true){
          qty = qty+1;
        }else{
          if(qty > 1){
            qty = qty-1;
          }else{
            qty = 1;
          }
        }
        
      
        updateCrtQty(qty);
      });
    
      $('.quantity-input').keyup(function(){  
        updateCrtQty($(this).val())
      });    
    
    
      function updateCrtQty(qty){
        console.log('Yandex: 99999');
        
        if(qty != ''){
        
          yp_product.items[0].quantity.count = qty;
          yp_product.items[0].amount = yp_product.items[0].amount * qty;
        
          var cart = {
            cart: yp_product,
            metadata: yp_any_data
          }; 
          
          if(yandexPayCheckoutData != false){
            yandexPayCheckoutData.update(cart);
            console.log('Yandex: корзина обновлена');
          }        
        }
      }    
    } 

  });    

    function btnViewCheck(){      
      var btnProductCard = $('.yandex-pay-button-product-card');
      var btnCart = $('.yandex-pay-button-cart');
      var btnCheckout = $('.yandex-pay-button-checkout');
      
      if(btnProductCard.length > 0 && yp_settings.btn_view_product_card == 0){
        btnProductCard.remove();
        return false;
      }
      
      if(btnCart.length > 0 && yp_settings.btn_view_cart == 0){
        btnCart.remove();
        return false;
      }
      
      if(btnCheckout.length > 0 && yp_settings.btn_view_checkout == 0){
        btnCheckout.remove();
        return false;
      }
      
      return true;      
    }
    
    /*
     * Обработка событий
     *
    */
    function onCheckoutSuccess(event){
      debugMessages('Yandex Pay: onCheckoutSuccess');
      debugMessages(event);
      
      $.ajax({
        url         : '/index.php/component/com_yandexpay/yandexpay/v1/clearcart',
        type        : 'POST',
        data        : {
          orderId: event.orderId,
          },
        dataType    : 'json',       
        success     : function( respond, status, jqXHR ){

          // Редирект на дефолтную страницу успешного заказа
          window.location.href = '/index.php/cart/orderdone';
        },
        error: function( jqXHR, status, errorThrown ){
          console.log( 'ОШИБКА AJAX запроса: ' + status, jqXHR );
        }
      });
      
      return false;
    }
    
    function onCheckoutError(event){
      debugMessages('Yandex Pay: onCheckoutError');
      debugMessages(event);  
    }
    
    function onCheckoutAbort(event){
      debugMessages('Yandex Pay: onCheckoutAbort');
      debugMessages(event);
    }
    
    function onPaymentButtonClick(event){
      debugMessages('Yandex Pay: onPaymentButtonClick');
      paymentObject.checkout();
    }

  function debugMessages(message){
    if(debugStatus){
      console.log(message);
    }
  }

})(jQuery);