<?php
/**
 * @package   Yandex pay
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 * Вывод информации о товарах на странице корзины
 *
 */
 
defined('_JEXEC') or die;

$show_button = false;
$uri = JUri::getInstance();
$url_path = $uri->getPath();
$url_query = $uri->getQuery();

if($url_path == '/index.php/cart' || 
   $url_query == 'option=com_virtuemart&view=cart' ||
   $url_path == '/index.php/cart/checkout'){
   
  JLoader::register('YPHelpers', JPATH_ROOT . '/libraries/yandexapi/YPHelpers.php');
  $YPHelpers = new YPHelpers();

  $currency_model = VmModel::getModel('currency');
  $session = JFactory::getSession();
  $cartSession = $session->get('vmcart',0,'vm');
  $temp_cart_id = $session->get('temp_cart_id', 0, 'YandexPay');

  if($temp_cart_id == 0){
    $cart_id = $YPHelpers->saveCart($cartSession);
    $temp_cart_id = $YPHelpers->createTempOrderID($cart_id);
    $YPHelpers->updateCart($cart_id, null,  $temp_cart_id, null);
    $session->set('temp_cart_id', $temp_cart_id, 'YandexPay');
  }else{
    $temp_cart_id = explode('_', $temp_cart_id);
    $YPHelpers->updateCart($temp_cart_id[0], $cartSession);
  }  

  $cartSession = (object)json_decode( $cartSession ,true);

  $cart = VirtueMartCart::getCart();
  $cart->getCartPrices();
  $products = [];

  foreach($cart->cartProductsData as $pos=>$product){
    $sales_price = $cart->cartPrices[$pos]['salesPriceTt'];

    $products[]= (object)[       
      'productId' => strval($product['virtuemart_product_id']),
      'amount' => strval($sales_price),
      'quantity' => (object)['count' => $product['quantity']]
    ];
  }

  $yp_product = [
    'externalId' => $temp_cart_id,
    'items' => $products,
  ];

  $yp_settings = $YPHelpers->getSettings();
  $currency = $currency_model->getCurrency( $cart->pricesCurrency );
  $yp_currency = $currency->currency_code_3;
  $yp_any_data = 'cart';

  require JModuleHelper::getLayoutPath('mod_yandexpay', $params->get('layout', 'yandex_pay_cart_btn'));
}