<?php
/**
 * @package   Yandex pay
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 * Вывод кнопки в карточке товара
 *
 */
 

// no direct access
defined('_JEXEC') or die('Restricted access');

class plgVmCustomYpcustom extends vmCustomPlugin {

	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);    
    JLoader::register('YPHelpers', JPATH_ROOT . '/libraries/yandexapi/YPHelpers.php');
	}

	function plgVmDeclarePluginParamsCustomVM3(&$data){
		return $this->declarePluginParams('custom', $data);
	}
  
  /*
   * Редактирование товара. Информация о custom field Yandex pay
   *
  */
	function plgVmOnProductEdit($field, $product_id, &$row,&$retValue) {

		if ($field->custom_element != $this->_name){
      return '';
    }

		$html ='<fieldset>'.vmText::_('VMCUSTOM_YPCUSTOM_TXT_1').'</fieldset>';
		$retValue .= $html;
    
		$row++;
		return true ;
	}

  /*
   * Карочка товара. Выводим информацию о товаре для кнопки Yandex pay
   *
  */
	function plgVmOnDisplayProductFEVM3(&$product,&$group) {

		if ($group->custom_element != $this->_name){
      return '';
    }
    
    $currency_model = VmModel::getModel('currency');
    $YPHelpers = new YPHelpers();
    $yp_settings = $YPHelpers->getSettings();

    if($yp_settings == false){
      return '';
    }
    
    // Товар
    $properties = $product->getProperties();
    $currency = $currency_model->getCurrency( $product->product_currency );    

    $yp_product = (object)[
      'externalId' => $YPHelpers->createTempOrderID('empty'),
      'items' => [
        (object)[
          'title' => $properties['product_name'].' ( sku: '.$properties['product_sku'].' )',
          'productId' => $properties['virtuemart_product_id'],
          'discountedUnitPrice' => strval($properties['prices']['salesPrice']),
          'amount' => strval($properties['prices']['salesPrice']),
          'quantity' => (object)['count' => 1]
        ],
      ],
    ];

    $data = [
      'yp_settings' => $yp_settings,
      'yp_product' => $yp_product,
      'yp_currency' => $currency->currency_code_3,
      'yp_any_data' => 'product_card',
    ];

    $group->display .= $this->renderByLayout( 'yandex_pay_field_formatter', $data );

		return true;
	}
}


